 %Background Removal Tool

    %This program will hopefully remove background from all the files
    %Currently runs on all csvs and will output to the same folder and
    %create a concatenated csv of all datasets

function backsub
    time = 86400%input('Enter Background Time(s): ')
    
    %collect list of all csv files in folder
    files = dir(fullfile(pwd,'*.csv'));
    
    background = csvread('Back-T-24.csv',7,1); %Read csv background final
    background(:,2) = background(:,2)/time; % Conhorz the Counts into CPS
    %all calculations use background as counts/second
    energies = linspace(0,1680,1680)';
    %create 1680 interpolation points in a column vector spaced evenly
    %between 0 and 1680kev 1680 is a convenient and close highly composite
    %number. This will be the range selected for calculation
    
    
    

    interp = interp1(background(:,1),background(:,2),energies);
    % interpolate values into a column vector at the specified
    
    % generate a moving average for the 1% around the cesium-137 peak, this
    % is approximately 7kev
    interp = movmean(interp,7);
    
    % after interpolation join together energies and interpolated values
    iback = horzcat(energies,interp); %joins together energies and interpolated values
    
    clear interp;
    
    csvwrite("0_iback.csv",iback); % write the interpolated modified csv

    
    number = numel(files);
    %Generate an array to store the energies and all the graph values after
    %fixing
    fixed = zeros(length(energies),number); %array of all scans with background removed first column is energies
    %set first row to energies
    % zeros are initialized for speed later. This matrix isn't particularly
    % large, but this is more general.
    
  
    names=cell(1,number) ;%array of all names initialized with energy as its first value
    % the name is saved for all  for all csv files and stored here for
    % output later
    
   
   
    
    
    for i=1:number
        fname=files(i).name; %gets filename from file structure
        disp(fname);
        dtime = csvread(fname,2,1,[2,1,2,1]); %get scan runtime for calculating cps
        data = csvread(fname,7,1); %reads from ith file into data array in ith position
        data(:,2) = data(:,2)./dtime ; %calculates cps
        disp(fname)
        interp = interp1(data(:,1),data(:,2),energies); %interpolate datapoints for the file
        
        interp = movmean(interp,7); % average for the 7 values around the point
        
        idata = horzcat(energies,interp); % Generate interpolated arrays
        
        rdata = idata(:,2)-iback(:,2); %removed background data
        
        rary = horzcat(energies,rdata);  
        
        fixed(:,i)=rdata; % add on removed background values to fixed
        
        names{i+1}=cellstr(fname); %sets column header in fixed (concatenated) array to the name of the file for that column
        
        
        %modify filename and write new csv values to modified array
        fname = "0_"+fname; % set filename
        csvwrite(fname,rary); % write csv file
        
        clear fname dtime data interp idata rdata rary ; % clear variables for next run through
        
    end  
     
        
        %csvwrite('0_fullarray.csv',vertcat(names,fixed));
end
    
% what I am doing. currently generating datatype to store full set of data
% for csv. Need to figure out how to write all 1680 values to separate
% locations in cell array or to add string to the header of the csv.
    %Now I am thinking to compile an array of strings to add to the
    %beginning of the csv and then write the rest after.



